import requests, urllib, os, requests.auth
import pymongo, ftplib


def RedditGalleryExtractor(imgURL):
    try:
        convertedURL = imgURL.replace('www.reddit.com', 'old.reddit.com')
        link = convertedURL.replace('/gallery/', '/comments/') + ".json"
        token = getToken()
        req = requests.get(link,
                           headers={
                               "User-Agent":
                               "script:thigh checker:v.1.0 (by /u/aizoule)",
                               "Authorization": "Bearer" + token
                           })
        if req.status_code == 200:
            galleryJson = req.json()
            media_metadata = galleryJson[0]['data']['children'][0]['data'][
                'media_metadata']
            imgURLs = []
            for k, v in media_metadata.items():
                imageID = v['id']
                imgExt = media_metadata[imageID]['m'].replace('image/', '')
                imageURL = "https://i.redd.it/" + imageID + "." + imgExt
                imgURLs.append(imageURL)
            return imgURLs[::-1]
    except KeyError:
        print(imgURL)
        pass
    except AttributeError:
        print(imgURL)
        pass
    except Exception as e:
        print(e)
        pass


def ImgurGalleryExtractor(imgURL):
    try:
        if "imgur.com/a/" in imgURL:
            beforePostID = "https://api.imgur.com/post/v1/albums/"
            afterPostID = "?client_id=546c25a59c58ad7&include=media"
            postID = imgURL.split('/')[::-1][0]
            link = beforePostID + postID + afterPostID
            req = requests.get(link)
            if req.status_code == 404:
                pass
            else:
                contentJson = req.json()
                for i in contentJson['media']:
                    imageURL = i['url']
                    print(f"{imageURL} exported from imgur album.")
                    return imageURL
        else:
            download(imgURL)
    except Exception as e:
        print(e)
        pass


def download(imageURL):
    if imageURL is None:
        return False
    try:
        fileName = imageURL.split('/')[-1]
        check_exists = requests.post("https://seethighs.online/check_file.php",
        json={"filename": fileName})
        if check_exists.json()['status'] == 'success':
            return False
        else:
            fpath = "thighs/" + fileName
            if os.path.exists(fpath):
                return False
            if fileName == "":
                return False
            else:
                headers = {"User-Agent": "thighchecker v1.0"}
                image = requests.get(imageURL,
                                     headers=headers,
                                     allow_redirects=False)
                if image.status_code == 200:
                    with open("thighs/" + fileName, 'wb') as f:
                        f.write(image.content)
                    return fileName
                elif image.status_code == 302:
                    return False
                else:
                    return False
    except Exception as e:
        print(f"While downloading {imageURL} as {fileName} an error occured.")
        print(e)
        return False


def checkDomain(imgURL, item):
    try:
        domain = imgURL.split('/')[2]
        if domain == "www.imgur.com" or domain == "imgur.com":
            return "imgurAlbum"
        elif domain == "www.reddit.com" or domain == "old.reddit.com":
            return "redditGallery"
        elif domain == "i.imgur.com" or domain == "i.redd.it" or domain == "files.catbox.moe":
            return "direct"
        else:
            return "unknown domain"
    except IndexError:
        print(f"Index error: {item}")
        pass


def getToken():
    auth_url = "https://www.reddit.com/api/v1/access_token"
    CLIENT_ID = "JWn0q4kkDS6e6vYuJOQ8OA"
    CLIENT_SECRET = "kAy0ech5xNa5s1f8MDOQjw2S9-KZYQ"
    client_auth = requests.auth.HTTPBasicAuth(CLIENT_ID, CLIENT_SECRET)
    payload = {"grant_type": "client_credentials"}
    headers = {
        'User-Agent': "script:thigh checker:v.1.0 (by /u/aizoule)",
        "Content-Type": "application/x-www-form-urlencoded"
    }
    response = requests.post(auth_url,
                             auth=client_auth,
                             data=payload,
                             headers=headers)
    token = response.json()['access_token']
    return token


def uploader(fileName):
    try:
        with open("thighs/" + fileName, "rb") as f:
            ftp.storbinary(f"STOR {fileName}", f)
        os.remove("thighs/" + fileName)
    except Exception as e:
        print(f"While uploading {fileName} an error occured.")
        os.remove("thighs/" + fileName)
        print(e)


def main():
    global ftp
    client_user, client_pass = urllib.parse.quote("admin"), urllib.parse.quote(
        "4512645126")
    client_string = f"mongodb://{client_user}:{client_pass}@ac-6lamrqw-shard-00-00.wfdfe9l.mongodb.net:27017,ac-6lamrqw-shard-00-01.wfdfe9l.mongodb.net:27017,ac-6lamrqw-shard-00-02.wfdfe9l.mongodb.net:27017/?ssl=true&replicaSet=atlas-buqc3u-shard-0&authSource=admin&retryWrites=true&w=majority"
    client = pymongo.MongoClient(client_string)
    db = client['images']
    data = db['data']
    ftp_server = "ftp.seethighs.online"
    ftp_user = "aizoule@seethighs.online"
    ftp_pass = "45126+45126Ea"
    ftp = ftplib.FTP(ftp_server, ftp_user, ftp_pass)
    ftp.cwd("public_html/thighs")
    with open("skip.txt", "r") as f:
        y = int(f.read())
    z = 0
    try:
        for item in data.find(batch_size=10).skip(y):
            y += 1
            imgURL = item["imageURL"]
            domain = checkDomain(imgURL, item)
            if domain == "imgurAlbum":
                download_imgur = download(ImgurGalleryExtractor(imgURL))
                if download_imgur is not False:
                    z += 1
                    uploader(download_imgur)
            elif domain == "redditGallery":
                reddit_images = RedditGalleryExtractor(imgURL)
                if reddit_images is not None:
                    for galleryItemURL in reddit_images:
                        download_reddit = download(galleryItemURL)
                        if download_reddit is not False:
                            z += 1
                            uploader(download_reddit)
            elif domain == "direct":
                download_direct = download(imgURL)
                if download_direct is not False:
                    z += 1
                    uploader(download_direct)
            elif domain == "unknown domain":
                print(f"unknown domain: {imgURL}")
            else:
                print(f"error {imgURL}")
            print(f"{y} links checked, {z} file downloaded.")
        ftp.quit()
        with open("skip.txt", "w") as f:
            f.write(str(y))
    except Exception as e:
        print(f"{y-1} file checked before crash.")
        with open("skip.txt", "w") as f:
            f.write(str(y - 1))
        print(e)


if __name__ == "__main__":
    main()
